package main;
use XmGrace;
use Common;
use ReadConfig;
use RedshiftUtil qw(:all);
use MultiThread;
use File::Path;
use File::Copy;
use Cwd 'abs_path';

$hq = ($ENV{HIGH_QUALITY} ? 1 : 0);
$MultiThread::threadlimit = 4;
$ProcessTemplate::doforks = 0;
$XmGrace::MultiThread = 1;

our $dir = "./plots";
our $h0 = 0.68;
if (@ARGV>0) {
    my $c = new ReadConfig($ARGV[0]);
    $c->{OUTBASE} ||= ".";
    $dir = $c->{OUTBASE}."/plots";
    $h0 = $c->{h0} if ($c->{h0});
}

our $cwd = abs_path();
$cwd =~ s/UniverseMachine.*?$/UniverseMachine/;
our $paperdir = $cwd.'/paper';
our $obsdir = $cwd.'/data';
our $mcmcdir = $cwd.'/mcmc_runs';
our $scriptdir = $cwd.'/plots';
1;
