#!/usr/bin/perl -w
package Xfer;
use MultiThread;

our $method = "scp";

sub new {
    my ($class, $files, $dest, $threads) = @_;
    $threads ||= 8;
    my $old_limit = $MultiThread::threadlimit;
    for (@$files) {
	next unless MultiThread::ForkChild();
	transfer_scp($_, $dest);
	exit;
    }
    MultiThread::WaitForChildren();
    $MultiThread::threadlimit = $old_limit;
}

sub transfer_scp {
    system("scp", $_[0], $_[1]);
}

1;
