#include <math.h>
#define DIM 2
#define NUM_PARAMS 2
#define INITIAL_GUESS {10.25, 0.07}
//#define SAVE_STEPS
#define NUM_STEPS 10000

double cached_rank(double x) {
  return (0.5+0.5*erf(x*M_SQRT1_2));
}

double calc_val(double *model, double *pos) {
  double midp = model[0];
  //double width = model[1];
  double width2 = model[1];

  //double midp = (mid-width)+2.0*width*cached_rank((pos[0]-mid)/width);
  return cached_rank((pos[1]-midp)/width2);
}

#define TOL 0.01
#include "../multi_fitter.c"

